> For the complete documentation index, see [llms.txt](https://docs.360dialog.com/docs/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.360dialog.com/docs/messaging/overview/typing-indicators.md).

# Typing Indicators

Typing indicators allow a business integration to signal that a reply is being composed after an incoming message is received. When triggered, WhatsApp marks the message as read, then displays a typing indicator in the conversation until a response message is sent. If a response message is not sent within 25 seconds, the indicator is automatically dismissed.

Typing indicators are useful when additional processing time is required before sending a response, such as calling external services or performing complex business logic.

### Send a typing indicator

<mark style="color:orange;">`POST`</mark> `https://waba-v2.360dialog.io/messages`

To send a typing indicator, use the request URL, the following headers, and JSON body.

```json
{ 
   "messaging_product": "whatsapp",
   "status": "read",
   "message_id": "<WHATSAPP_MESSAGE_ID>",
   "typing_indicator": {
     "type": "text"
   }
}
```

#### Headers

| Name         | Value                  |
| ------------ | ---------------------- |
| Content-Type | application/json       |
| D360-API-KEY | Your 360Dialog API key |

#### Request Body

| Name                                                 | Type   | Description                                                                                         |
| ---------------------------------------------------- | ------ | --------------------------------------------------------------------------------------------------- |
| messaging\_product<mark style="color:red;">\*</mark> | string | Must be set to `"whatsapp"`.                                                                        |
| status<mark style="color:red;">\*</mark>             | string | The message must be marked `"read"` before displaying a typing indicator. Use `"read"`.             |
| message\_id<mark style="color:red;">\*</mark>        | string | ID of the incoming message to mark as read and send a typing indicator for. Starts with `"wamid."`. |
| typing\_indicator<mark style="color:red;">\*</mark>  | object | An object which contains a `"type"` key, whose value must be `"text"`.                              |

{% tabs %}
{% tab title="200: Success " %}
A successful request results in a  `"success": true` response:

```json
{
    "success": true
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.360dialog.com/docs/messaging/overview/typing-indicators.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
